unit Canvas;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, ImgList, ActnList, Menus, ExtCtrls, ExtDlgs,
  StdCtrls, ExtActns, StdActns;

type
  TForm_Canvas = class(TForm)
    C_ToolBar: TToolBar;
    StatusBar1: TStatusBar;
    ScrollBox1: TScrollBox;
    C_Canvas: TImage;
    Button_FN: TToolButton;
    Button_FO: TToolButton;
    Button_FS: TToolButton;
    ToolButtonDiv1: TToolButton;
    SaveDialog1: TSaveDialog;
    ToolButton1: TToolButton;
    C_ActionList: TActionList;
    C_ImageList: TImageList;
    FileSave1: TAction;
    FileNew1: TAction;
    C_Menu: TMainMenu;
    Files1: TMenuItem;
    New1: TMenuItem;
    N1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    FileOpen1: TFileOpen;
    FileSaveAs1: TFileSaveAs;
    FileExit1: TFileExit;
    Open1: TMenuItem;
    OpenPicture1: TOpenPicture;
    Open2: TMenuItem;
    Save2: TMenuItem;
    SaveAsPicture1: TSavePicture;
    SaveAs2: TMenuItem;
    Button_FOP: TToolButton;
    Button_FSP: TToolButton;
    SavePicture1: TAction;
    ToolButton2: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure OpenPicture1Accept(Sender: TObject);
    procedure SaveAsPicture1Accept(Sender: TObject);
    procedure SavePicture1Execute(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure CompoundLayer;
  private
    { Private 錾 }
    procedure WMEraseBkgnd(var m: TWMEraseBkgnd); message WM_ERASEBKGND;
  public
    { Public 錾 }

    _CLayer  : Array of TBitmap; // C[`p
    _NoGrid  : TBitmap; // ObhȂ\p
    _BGLayer : TBitmap; // wi摜p

    _ChipArray : Array of Array of Integer; // `bvzuۑp
  end;

var
  Form_Canvas: TForm_Canvas;

  CurrentFile : String;
  
  _CCursor : TBitmap; // J[\`p

implementation

uses Grid, Palette;

{$R *.dfm}

procedure TForm_Canvas.WMEraseBkgnd(var m : TWMEraseBkgnd);
begin
  m.Result := LRESULT(False); // ĕ`掞̂}鏈B炵B
end;                          // twvATBitmap ibmpformu.pasj

procedure TForm_Canvas.FormCreate(Sender: TObject);
begin
//  SetLength(_CLayer, 1); // pBitmap̏ݒ
//  _CLayer[0] := TBitmap.Create;

  _BGLayer := TBitmap.Create; // wi摜pBitmap

  _NoGrid := TBitmap.Create; // ObhȂ\pBitmap
end;

procedure TForm_Canvas.OpenPicture1Accept(Sender: TObject);
begin
  CurrentFile := OpenPicture1.Dialog.FileName; // t@Cǂݍ
  _BGLayer.LoadFromFile(CurrentFile);

  C_Canvas.Width  := _BGLayer.Width;  // \ݒ
  C_Canvas.Height := _BGLayer.Height; // \ݒ

  C_Canvas.Picture.Bitmap.Width  := _BGLayer.Width;  // \̗̈敝ݒ
  C_Canvas.Picture.Bitmap.Height := _BGLayer.Height; // \̗̈捂ݒ

  _NoGrid.Width  := _BGLayer.Width;  // ObhȂ摜̗̈敝ݒ
  _NoGrid.Height := _BGLayer.Height; // ObhȂ摜̗̈捂ݒ

  Form_Grid._CGrid.Width  := _BGLayer.Width;  // Obh`̗̈敝ݒ
  Form_Grid._CGrid.Height := _BGLayer.Height; // Obh`̗̈捂ݒ
  Form_Grid.DrawGrid; // ݂̃Obh`

  CompoundLayer; // `ʂ̍ƕ\
{
  _NoGrid.Assign(_BGLayer);

  case Form_Grid._GMode of // ݂̑Iɍ킹ăObh\
    gtSquare  : Form_Grid.Btn_Square.Click;
    gtHexH    : Form_Grid.Btn_HexH.Click;
    gtHexV    : Form_Grid.Btn_HexV.Click;
    gtDiamond : Form_Grid.Btn_Diamond.Click;
  else
    Form_Grid.Btn_Nothing.Click;
  end;
}
end;

procedure TForm_Canvas.SaveAsPicture1Accept(Sender: TObject);
begin
  CurrentFile := SaveAsPicture1.Dialog.FileName; // t@Cmۂ
  SavePicture1.OnExecute(Sender); // ȍ~͏㏑ۑƓ
end;

procedure TForm_Canvas.SavePicture1Execute(Sender: TObject);
var
  Msg_Save : String;
  FiletoFind : String;
begin
  Msg_Save := '㏑܂B낵łH';

  FileToFind := FileSearch(CurrentFile, GetCurrentDir); // t@C̗LmF
  if (FileToFind = '') // t@C݂ȂꍇA܂͏㏑OK̏ꍇ
    or (Messagedlg(Msg_Save, mtConfirmation, mbOKCancel, 0) = mrOK) then
  begin
    if (Form_Grid.Check_Grid.Checked) then // Obhtŉ摜ۑꍇ
    begin
      C_Canvas.Picture.SaveToFile(CurrentFile); // Obht摜ۑ
    end
    else // ObhȂŉ摜ۑꍇ
      _NoGrid.SaveToFile(CurrentFile); // ObhȂ摜ۑ
  end
  else // t@C݂A㏑sȂ
  begin
    SaveAsPicture1.ExecuteTarget(Sender); // VKۑƓ
  end;
end;

procedure TForm_Canvas.ToolButton1Click(Sender: TObject);
begin
  Form_Grid.Visible := ToolButton1.Down;
end;

procedure TForm_Canvas.ToolButton2Click(Sender: TObject);
begin
  Form_Palette.Visible := ToolButton2.Down;
end;

procedure TForm_Canvas.CompoundLayer;
begin
// Obh̕\}ƓɁA
// pbgAObhAJ[\摜̍ōsB
//
  C_Canvas.Picture.Assign(_BGLayer); // wi摜

  _NoGrid.Assign(C_Canvas.Picture); // ܂ł̍摜ʂɕۑ
  C_Canvas.Canvas.Draw(0,0, Form_Grid._CGrid); // \ߕ`ꂽObh摜
end;

end.
